using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Cors;
using Microsoft.AspNetCore.Mvc;
using System;
using WK_KLI_LAPS_Service.App_Data;
using WK_KLI_LAPS_Service.Models.Master;

// For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860

namespace WK_KLI_LAPS_Service.Controllers.Master.CustomerContact
{
    [EnableCors("CorsPolicy")]
    [Authorize]
    [ApiController]
    [Route("api/[controller]")]
    public class CustomerContactApiController : ControllerBase
    {
        CommonRepository oCommonRepository = new CommonRepository();

        private ICustomerContactService _CustomerContactservices;
        public CustomerContactApiController(ICustomerContactService CustomerContactServices)
        {
            _CustomerContactservices = CustomerContactServices;

        }


        [Authorize]
        [HttpGet]
        //Code to retrieve all data
        public IActionResult GetAll()
        {
            var _list = _CustomerContactservices.GetAll();
            return Ok(_list);
        }

        [Authorize]
        [HttpGet("GetActiveCustomerContact")]
        //Code to retrieve active data
        public IActionResult GetActiveCustomerContact()
        {
            var _list = _CustomerContactservices.GetActiveCustomerContact();
            return Ok(_list);
        }
        //Code to add new record
        [Authorize]
        [HttpPost("Add")]
        public IActionResult Add([FromBody] customercontactModel ocustomercontactModel)
        {

            int retval = 0;
            try
            {
                retval = _CustomerContactservices.Add(ocustomercontactModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }

        }
        //Code to update specific record
        [Authorize]
        [HttpPost("Update")]
        public IActionResult Update([FromBody] customercontactModel ocustomercontactModel)
        {
            int retval = 0;
            try
            {
                retval = _CustomerContactservices.Edit(ocustomercontactModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }

        }


        //Code to activate or deactivate specific record
        [Authorize]
        [HttpPost("Delete")]
        public IActionResult Delete([FromBody] customercontactModel ocustomercontactModel)
        {
            int retval = 0;
            try
            {
                retval = _CustomerContactservices.Delete(ocustomercontactModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }
        }
    }
}